
#ifndef  __ICS_RL78G14_H
#define  __ICS_RL78G14_H

/***** (Internal use) start *****/
#define   ICS_CPU_30PIN   (0x00L)
#define   ICS_CPU_32PIN   (0x10L)
#define   ICS_CPU_36PIN   (0x20L)
#define   ICS_CPU_40PIN   (0x30L)
#define   ICS_CPU_44PIN   (0x40L)
#define   ICS_CPU_48PIN   (0x50L)
#define   ICS_CPU_52PIN   (0x60L)
#define   ICS_CPU_64PIN   (0x70L)
#define   ICS_CPU_80PIN   (0x80L)
#define   ICS_CPU_100PIN  (0x90L)

#define   ICS_R5F104Ax    (ICS_CPU_30PIN)
#define   ICS_R5F104Bx    (ICS_CPU_32PIN)
#define   ICS_R5F104Cx    (ICS_CPU_36PIN)
#define   ICS_R5F104Ex    (ICS_CPU_40PIN)
#define   ICS_R5F104Fx    (ICS_CPU_44PIN)
#define   ICS_R5F104Gx    (ICS_CPU_48PIN)
#define   ICS_R5F104Jx    (ICS_CPU_52PIN)
#define   ICS_R5F104Lx    (ICS_CPU_64PIN)
#define   ICS_R5F104Mx    (ICS_CPU_80PIN)
#define   ICS_R5F104Px    (ICS_CPU_100PIN)

//                                       A   B  BGA  E   F   G   J   L   M   P
//                                   // 30p 32p 36p 40p 44p 48p 52p 64p 80p 100p
#define   ICS_SCI0_P51_P50    (0x00) //  ?   ?   ?   ?   ?   ?   ?   ?   ?   ?  
#define   ICS_SCI0_P17_P16    (0x01) //  -  (?) (?) (?) (?) (?) (?) (?) (?) (?) 
#define   ICS_SCI0_P12_P11    (0x02) //  -   -   -   -   -   ?>  -   ?>  ?>  ?>  over384kB
#define   ICS_SCI1_P02_P03    (0x10) //  -   -   -   -   -   -   ?   ?   ?   ?  
#define   ICS_SCI1_P00_P01    (0x11) //  ?   ?   ?   ?   ?   ?   -   -   -   -  
#define   ICS_SCI1_P82_P81    (0x12) //  -   -   -   -   -   -   -   -   -  (?) 
#define   ICS_SCI2_P77_P76    (0x20) //  -   -   -   -   -   -  (?) (?) (?) (?) 
#define   ICS_SCI2_P13_P14    (0x21) //  ?   ?   ?   ?   ?   ?   ?   ?   ?   ?  
#define   ICS_SCI3_P144_P143  (0x30) //  -   -   -   -   -   -   -   -   ?   ?  


#define   ICS_R5F104xA_16K    
#define   ICS_R5F104xC_32K    
#define   ICS_R5F104xD_48K    
#define   ICS_R5F104xE_64K    
#define   ICS_R5F104xF_96K    
#define   ICS_R5F104xG_128K   
#define   ICS_R5F104xH_192K   
#define   ICS_R5F104xJ_256K   
#define   ICS_R5F104xK_384K   
#define   ICS_R5F104xL_512K   
/***** (Internal use) end *****/

/***** (for user definition) begin *****/
#define   ICS_R5F104Ax_SCI0_P51_P50   ((ICS_R5F104Ax<<8)|ICS_SCI0_P51_P50)
#define   ICS_R5F104Ax_SCI1_P00_P01   ((ICS_R5F104Ax<<8)|ICS_SCI1_P00_P01)
#define   ICS_R5F104Ax_SCI2_P13_P14   ((ICS_R5F104Ax<<8)|ICS_SCI2_P13_P14)

#define   ICS_R5F104Bx_SCI0_P51_P50   ((ICS_R5F104Bx<<8)|ICS_SCI0_P51_P50)
#define   ICS_R5F104Bx_SCI0_P17_P16   ((ICS_R5F104Bx<<8)|ICS_SCI0_P17_P16)
#define   ICS_R5F104Bx_SCI1_P00_P01   ((ICS_R5F104Bx<<8)|ICS_SCI1_P00_P01)
#define   ICS_R5F104Bx_SCI2_P13_P14   ((ICS_R5F104Bx<<8)|ICS_SCI2_P13_P14)

// No support for BGA package

#define   ICS_R5F104Ex_SCI0_P51_P50   ((ICS_R5F104Ex<<8)|ICS_SCI0_P51_P50)
#define   ICS_R5F104Ex_SCI0_P17_P16   ((ICS_R5F104Ex<<8)|ICS_SCI0_P17_P16)
#define   ICS_R5F104Ex_SCI1_P00_P01   ((ICS_R5F104Ex<<8)|ICS_SCI1_P00_P01)
#define   ICS_R5F104Ex_SCI2_P13_P14   ((ICS_R5F104Ex<<8)|ICS_SCI2_P13_P14)

#define   ICS_R5F104Fx_SCI0_P51_P50   ((ICS_R5F104Fx<<8)|ICS_SCI0_P51_P50)
#define   ICS_R5F104Fx_SCI0_P17_P16   ((ICS_R5F104Fx<<8)|ICS_SCI0_P17_P16)
#define   ICS_R5F104Fx_SCI1_P00_P01   ((ICS_R5F104Fx<<8)|ICS_SCI1_P00_P01)
#define   ICS_R5F104Fx_SCI2_P13_P14   ((ICS_R5F104Fx<<8)|ICS_SCI2_P13_P14)

#define   ICS_R5F104Gx_SCI0_P51_P50   ((ICS_R5F104Gx<<8)|ICS_SCI0_P51_P50)
#define   ICS_R5F104Gx_SCI0_P17_P16   ((ICS_R5F104Gx<<8)|ICS_SCI0_P17_P16)
#define   ICS_R5F104Gx_SCI0_P12_P11   ((ICS_R5F104Gx<<8)|ICS_SCI0_P12_P11)  // ROM 384kB over
#define   ICS_R5F104Gx_SCI1_P00_P01   ((ICS_R5F104Gx<<8)|ICS_SCI1_P00_P01)
#define   ICS_R5F104Gx_SCI2_P13_P14   ((ICS_R5F104Gx<<8)|ICS_SCI2_P13_P14)

#define   ICS_R5F104Jx_SCI0_P51_P50   ((ICS_R5F104Jx<<8)|ICS_SCI0_P51_P50)
#define   ICS_R5F104Jx_SCI0_P17_P16   ((ICS_R5F104Jx<<8)|ICS_SCI0_P17_P16)
#define   ICS_R5F104Jx_SCI1_P02_P03   ((ICS_R5F104Jx<<8)|ICS_SCI1_P02_P03)
#define   ICS_R5F104Jx_SCI2_P77_P76   ((ICS_R5F104Jx<<8)|ICS_SCI2_P77_P76)
#define   ICS_R5F104Jx_SCI2_P13_P14   ((ICS_R5F104Jx<<8)|ICS_SCI2_P13_P14)

#define   ICS_R5F104Lx_SCI0_P51_P50   ((ICS_R5F104Lx<<8)|ICS_SCI0_P51_P50)
#define   ICS_R5F104Lx_SCI0_P17_P16   ((ICS_R5F104Lx<<8)|ICS_SCI0_P17_P16)
#define   ICS_R5F104Lx_SCI0_P12_P11   ((ICS_R5F104Lx<<8)|ICS_SCI0_P12_P11)  // ROM 384kB over
#define   ICS_R5F104Lx_SCI1_P02_P03   ((ICS_R5F104Lx<<8)|ICS_SCI1_P02_P03)
#define   ICS_R5F104Lx_SCI2_P77_P76   ((ICS_R5F104Lx<<8)|ICS_SCI2_P77_P76)
#define   ICS_R5F104Lx_SCI2_P13_P14   ((ICS_R5F104Lx<<8)|ICS_SCI2_P13_P14)

#define   ICS_R5F104Mx_SCI0_P51_P50   ((ICS_R5F104Mx<<8)|ICS_SCI0_P51_P50)
#define   ICS_R5F104Mx_SCI0_P17_P16   ((ICS_R5F104Mx<<8)|ICS_SCI0_P17_P16)
#define   ICS_R5F104Mx_SCI0_P12_P11   ((ICS_R5F104Mx<<8)|ICS_SCI0_P12_P11)  // ROM 384kB over
#define   ICS_R5F104Mx_SCI1_P02_P03   ((ICS_R5F104Mx<<8)|ICS_SCI1_P02_P03)
#define   ICS_R5F104Mx_SCI2_P77_P76   ((ICS_R5F104Mx<<8)|ICS_SCI2_P77_P76)
#define   ICS_R5F104Mx_SCI2_P13_P14   ((ICS_R5F104Mx<<8)|ICS_SCI2_P13_P14)
#define   ICS_R5F104Mx_SCI3_P144_P143 ((ICS_R5F104Mx<<8)|ICS_SCI3_P144_P143)

#define   ICS_R5F104Px_SCI0_P51_P50   ((ICS_R5F104Px<<8)|ICS_SCI0_P51_P50)
#define   ICS_R5F104Px_SCI0_P17_P16   ((ICS_R5F104Px<<8)|ICS_SCI0_P17_P16)
#define   ICS_R5F104Px_SCI0_P12_P11   ((ICS_R5F104Px<<8)|ICS_SCI0_P12_P11)  // ROM 384kB over
#define   ICS_R5F104Px_SCI1_P02_P03   ((ICS_R5F104Px<<8)|ICS_SCI1_P02_P03)
#define   ICS_R5F104Px_SCI1_P82_P81   ((ICS_R5F104Px<<8)|ICS_SCI1_P82_P81)
#define   ICS_R5F104Px_SCI2_P77_P76   ((ICS_R5F104Px<<8)|ICS_SCI2_P77_P76)
#define   ICS_R5F104Px_SCI2_P13_P14   ((ICS_R5F104Px<<8)|ICS_SCI2_P13_P14)
#define   ICS_R5F104Px_SCI3_P144_P143 ((ICS_R5F104Px<<8)|ICS_SCI3_P144_P143)
/***** (for user definition) end *****/

void  ics2_init(uint16_t addr, uint16_t pin, uint8_t level, uint8_t num, uint8_t brr, uint8_t mode);
void  ics2_watchpoint(void); 
void  ics2_version(void);

void  int_ics_sci_tx(void);
void  int_ics_sci_rx(void);
void  int_ics_sci_err(void);

#endif
